package test;

import com.toshiba.extobservation.EventNotifierModule;
import com.toshiba.extobservation.ExtObservationModuleSide;
import com.toshiba.middleLanguage.MEvent;
import com.toshiba.middleLanguage.MTermList;

public class TestEventNotifierModule implements EventNotifierModule {

	private ExtObservationModuleSide receiver;


	public void getEvent(MEvent arg0, MTermList arg1) {
		System.out.println("called getEvent: "+arg0.toProlog());
		System.out.println("Condition: "+arg1.toProlog());
	}

	public void switchOn(MEvent arg0, MTermList arg1) {
		System.out.println("called switchOn: "+arg0.toProlog());
		System.out.println("Condition: "+arg1.toProlog());
	}
	
	public boolean isAbleToIssueEvent(MEvent event) {
		String name = event.getName();
		if (name.equals("beginAction")
				|| name.equals("succeedAction")
				|| name.equals("failAction")
				|| name.equals("suspendAction")
				|| name.equals("resumeAction")
				|| name.equals("clearAction")
				|| name.equals("beginGoal")
				|| name.equals("succeedGoal")
				|| name.equals("failGoal")
				|| name.equals("suspendGoal")
				|| name.equals("resumeGoal")) {
			return false;
		} else {
    		return true;        	
		}
	}

	public void switchOff(MEvent event) {
		System.out.println("called switchOff: "+event.toProlog());
	}

	public void setExtObservationModuleSide(ExtObservationModuleSide extObservationModuleSide) {
		this.setReceiver(extObservationModuleSide);
		
	}

	private void setReceiver(ExtObservationModuleSide extObservationModuleSide) {
		this.receiver = extObservationModuleSide;
	}
	
	public void notifyEventTest(MEvent mevent) {
		this.receiver.notifyEvent(mevent);
	}


	


}
